//ruwt.js
//Are You Watching This (RUWT) interface
var gameTags = ['points', 'channel', 'start', 'end', 'timeLeft'];
var gameArray = [];
var notuneArray = [];

function MajorToObjectId(major)
{
    var channelIndex;
    for(channelIndex = 0; channelIndex < channelArray.length; ++channelIndex) {
        if(channelArray[channelIndex].major == major &&
           channelArray[channelIndex].hd == 1)
            return channelArray[channelIndex].objectId;
    }
    return 0;
}

var notuneTunerIndex;
function RuwtBitrate(text)
{
    var index;
    var i;
    var url;
    var objectId;
    var securityMode = 0;

    if (doTranscode)
        securityMode = 3;
    index = text.indexOf('value =');
    if(index > 0) {
        bitrate = text.substring(index + 7);
        bitrate = parseInt(bitrate);
        if(bitrate == 0) {
            objectId = tunerArray[notuneTunerIndex].objectId;
            for(i = 0; i < notuneArray.length; ++i) {
                if(notuneArray[i] == objectId)
                    break;
            }
            if(i > notuneArray.length)
                notuneArray.push(objectId);
            url = '/cgi-bin/webcmd?screen=TuneCard' +
                '&cardIp=' + tunerArray[notuneTunerIndex].cardIp +
                '&tuner=' + tunerArray[notuneTunerIndex].index +
                '&ip=' + tunerArray[notuneTunerIndex].ip +
                '&port=' + tunerArray[notuneTunerIndex].port +
                '&protocol=0&channelObjectId=0' +
                '&majorNum=206&minorNum=65535&streamId=1234' +
                '&securityMode=' + securityMode + '&persistent=1&quick=1' +
                '&ios6time=' + (new Date().getTime());
            DoPost(url);
        }
    }
}

function RuwtBlackout()
{
    var url;

    for(notuneTunerIndex = 0; notuneTunerIndex < tunerArray.length; ++notuneTunerIndex) {
        if(tunerArray[notuneTunerIndex].objectId != 0) {
            url = '/cgi-bin/webcmd?screen=getSet&getSetIp=';
            url += tunerArray[notuneTunerIndex].ip;
            url += 'name=bitrate&value=';
            url += tunerArray[notuneTunerIndex].index;
            DoPostCallback(url, RuwtBitrate);
        }
    }
    trace('notune=' + notuneArray);
}

function RuwtFlagHot()
{
    var game;
    var channelIndex;
    var index;
    var categories;
    var event;
    var points;
    var stars;

    //clear hot flag
    for(channelIndex = 0; channelIndex < channelArray.length; ++channelIndex) {
        categories = channelArray[channelIndex].categories;
        index = categories.indexOf(' HHH');
        if(index >= 0) {
            channelArray[channelIndex].categories = categories.substring(1, index);
            event = $('#chanElementCell3_' + channelIndex)[0].innerHTML;
            //remove stars
            index = event.indexOf(' <font');
            if(index >= 0) {
                event = event.substring(0, index);
                $('#chanElementCell3_' + channelIndex)[0].innerHTML = event;
            }
        }
    }
    //mark channels that are hot
    for(game = 0; game < gameArray.length; ++game) {
        trace(gameArray[game]);
        points = gameArray[game].points;
        if(points < 75) stars = '$';
        else if(points < 175) stars = '$$';
        else if(points < 275) stars = '$$$';
        else stars = '$$$$';
        stars = ' <font size=4 color=red>' + stars + '</font>';
        for(channelIndex = 0; channelIndex < channelArray.length; ++channelIndex) {
            if(channelArray[channelIndex].major == gameArray[game].channel &&
               channelArray[channelIndex].hd == 1) {
                channelArray[channelIndex].categories += ' HHH';
                $('#chanElementCell3_' + channelIndex)[0].innerHTML += ' ' + stars;
                break;
            }
        }
    }
}

//Is an adjacent TV already playing this channel?
function RuwtDistance(tvList, index, objectId)
{
    var tvIndex, i, index2, distance=6;
    for(i = -6; i <= 6; ++i) {
        if(i == 0)
            continue;
        index2 = index + i;
        if(index2 < 0 || index2 >= tvList.length)
            continue;
        tvIndex = tvList[index2];
        if(tvArray[tvIndex].objectId == objectId && Math.abs(i) < distance)
            distance = Math.abs(i);
    }
    return distance;
}

//A game can be tuned if: tv.hot > 0 && game.stars >= tv.hot
function RuwtTuneHot()
{
    var gameIndex, gameIndex2;
    var tvIndex;
    var points;
    var stars;
    var hot;
    var tvCount = 0;
    var hotCount = 0;
    var minCount;
    var i;
    var tvs;
    var now = Date.now();
    var timeout;
    var tvList;
    var tvValue;
    var distance;

    //How many TVs are watching each hot game?
    for(gameIndex = 0; gameIndex < gameArray.length; ++gameIndex) {
        gameArray[gameIndex]['tvs'] = 0;
        for(i = 0; i < notuneArray.length; ++i) {
            if(notuneArray[i] == gameArray[gameIndex].objectId)
                break;
        }
        if(i < notuneArray.length)
            continue;
        ++hotCount;
    }
    tvList = [];
    tvValue = [];
    for(tvIndex = 0; tvIndex < tvArray.length; ++tvIndex) {
        if(tvArray[tvIndex].hot > 0)
            tvList.push(tvIndex);
        if(tvArray[tvIndex].hot == 1)
            ++tvCount;
        tvArray[tvIndex]['stars'] = 0;
        tvArray[tvIndex]['gameIndex'] = 10;
        for(gameIndex = 0; gameIndex < gameArray.length; ++gameIndex) {
            if(gameArray[gameIndex].objectId == tvArray[tvIndex].objectId) {
                ++gameArray[gameIndex].tvs;
                tvArray[tvIndex].stars = gameArray[gameIndex].stars;
                tvArray[tvIndex].gameIndex = gameIndex;
            }
        }
    }
    minCount = Math.round(tvCount / hotCount);
    if(minCount < 1)
        minCount = 1;

    //Tune all games
    for(gameIndex = 0; gameIndex < gameArray.length; ++gameIndex) {
        if(gameArray[gameIndex].tvs >= minCount)
            continue;  //already enough TVs
        for(i = 0; i < notuneArray.length; ++i) {
            if(notuneArray[i] == gameArray[gameIndex].objectId)
                break;
        }
        if(i < notuneArray.length)
            continue;  //blackout
        stars = gameArray[gameIndex].stars;

        for(tvs = gameArray[gameIndex].tvs; tvs < minCount; ++tvs) {
            bestValue = -1000;
            bestIndex = 0;
            for(i = 0; i < tvList.length; ++i) {
                tvValue[i] = -1000;
                tvIndex = tvList[i];
                if(tvArray[tvIndex].objectId == gameArray[gameIndex].objectId)
                    continue;  //already tuned
                if(tvArray[tvIndex].hot == 0)
                    continue;  //TV in manual mode
                if(stars < tvArray[tvIndex].hot)
                    continue;  //game not hot enough for TV
                if(tvArray[tvIndex].stars == 0)
                    timeout = 3600000;
                else
                    timeout = 7200000;
                if(tvPrevTime[tvIndex] != null && tvPrevTime[tvIndex] != 0 &&
                    now - tvPrevTime[tvIndex] < timeout)
                    continue;  //manual lockout
                gameIndex2 = tvArray[tvIndex].gameIndex;
                if(gameIndex2 < 6 && gameArray[gameIndex2].tvs <= minCount)
                    continue;  //keep minimum number of TVs
                tvValue[i] = tvArray[tvIndex].hot * 1000;
                tvValue[i] += tvArray[tvIndex].gameIndex * 10;
                distance = RuwtDistance(tvList, i, gameArray[gameIndex].objectId);
                tvValue[i] += distance;
                if(tvArray[tvIndex].objectId != 0) {
                    distance = RuwtDistance(tvList, i, tvArray[tvIndex].objectId);
                    tvValue[i] -= distance;
                }
                if(tvValue[i] > bestValue) {
                    bestValue = tvValue[i];
                    bestIndex = i;
                }
            }
            if(bestValue < 0)
                break;
            tvIndex = tvList[bestIndex];
            for(gameIndex2 = 0; gameIndex2 < gameArray.length; ++gameIndex2) {
                if(gameArray[gameIndex2].objectId == tvArray[tvIndex].objectId)
                    --gameArray[gameIndex2].tvs;
            }
            TvChanObjId(tvIndex, SOURCE_DIRECTV, gameArray[gameIndex].objectId);
            tvArray[tvIndex].stars = gameArray[gameIndex].stars;
            tvArray[tvIndex].gameIndex = gameIndex;
            ++gameArray[gameIndex].tvs;
        }
    }
}

var ruwtLine=[];

//parse XML into gameArray
function RuwtParse(node)
{
    var name;
    var value;
    var index;
    var i;
    var now;
    var myInt;
    var myString;

    if(node.childNodes.length == 0) {
        name = node.parentNode.nodeName;
        for(i = 0; i < gameTags.length; ++i) {
            if(gameTags[i] == name)
                break;
        }
        if(i >= gameTags.length || ruwtLine[name] != null)
            return;
        value = node.nodeValue;
        if(name == 'start' || name == 'end')
            value = Date.parse(value);
        myInt = parseInt(value);
        myString = "" + myInt;
        if(myString == value)
            value = myInt;
        ruwtLine[name] = value;
        return;
    }
    for(index = 0; index < node.childNodes.length; ++index)
        RuwtParse(node.childNodes[index]);
    if(node.nodeName == 'game') {
        var now = Date.now();
        if(ruwtLine.channel != null && ruwtLine.channel != 'www'
            && ruwtLine.start - 1000*60*15 <= now && now < ruwtLine.end + 1000*60*60
            && (now < ruwtLine.end || ruwtLine.timeLeft == null ||
                ('' + ruwtLine.timeLeft).substring(0, 5) != 'Final')
            )
            gameArray.push(ruwtLine);
        ruwtLine = [];
    }
}

function ruwtCompare(a, b) {
   return b.points - a.points;
}

function RuwtLoaded(text)
{
    var parser;
    var xmlDoc;
    var i, j;
    var gameIndex;
    var channelIndex;
    var points;
    var stars;

    trace('RuwtLoaded '+text.length);
    parser = new DOMParser();
    xmlDoc = parser.parseFromString(text, "text/xml");
    RuwtParse(xmlDoc.documentElement);  //populate gameArray
    gameArray.sort(ruwtCompare);
    //Remove duplicates
    for(i = 0; i < gameArray.length; ++i) {
        for(j = i + 1; j < gameArray.length; ++j) {
            if(gameArray[j].channel == gameArray[i].channel)
                gameArray.splice(j, 1);
        }
    }
    while(gameArray.length > 10)
        gameArray.pop();

    //FIXME
    //while(gameArray.length > 4)
    //    gameArray.pop();

    //Determine objectId and stars
    for(gameIndex = 0; gameIndex < gameArray.length; ++gameIndex) {
        gameArray[gameIndex]['objectId'] = 0;
        for(channelIndex = 0; channelIndex < channelArray.length; ++channelIndex) {
            if(channelArray[channelIndex].major == gameArray[gameIndex].channel &&
               channelArray[channelIndex].hd == 1) {
                gameArray[gameIndex]['objectId'] = channelArray[channelIndex].objectId;
                break;
            }
        }
        points = gameArray[gameIndex].points;
        if(points < 75) stars = 1;
        else if(points < 175) stars = 2;
        else if(points < 275) stars = 3;
        else stars = 4;
        gameArray[gameIndex]['stars'] = stars;
    }
    RuwtFlagHot();  //mark channels that are hot
    RuwtTuneHot();
}

function RuwtSetNotune()
{
    var notune, notune2;
    var major, major2;
    var objectId;
    var index, index2;

    if(notuneArray.length > 0)
        return;
    notune = ConfigValue('notune');
    for(;;) {
        major = parseInt(notune);
        if(major == 0)
            break;
        objectId = MajorToObjectId(major);
        if(objectId != 0)
            notuneArray.push(objectId);
        index2 = notune.indexOf('-');
        index = notune.indexOf(',');
        if(index2 > 0 && (index2 < index || index < 0)) {
            notune2 = notune.substring(index2 + 1);
            major2 = parseInt(notune2);
            while(++major <= major2) {
                objectId = MajorToObjectId(major);
                if(objectId != 0)
                    notuneArray.push(objectId);
            }
        }
        if(index < 0)
            break;
        notune = notune.substring(index + 1);
    }
    trace('notune=' + notuneArray);
}

//https://areyouwatchingthis.com/api/games.xml?postalCode=55415&msoID=DIRECTV&showJustTelevisedGames
function RuwtLoad()
{
    var proxy = '/cgi-bin/webcmd?screen=proxy&url=';
    var RUWT = 'https://areyouwatchingthis.com/api/games.xml?postalCode=';
    var RUWT2 = '&msoID=DIRECTV&showJustTelevisedGames';
    var postalCode;

    RuwtSetNotune();
    postalCode = ConfigValue('postalCode');
    if(postalCode == '')
        postalCode = '46032';
    var url = proxy + RUWT + postalCode + RUWT2;
    url += '&ios6time=' + (new Date().getTime());
    trace(url);
    gameArray = [];
    DoPostCallback(url, RuwtLoaded);
}

//----------------------------------

function RuwtTune(tvIndex, major)
{
    var channelIndex;
    for(channelIndex = 0; channelIndex < channelArray.length; ++channelIndex) {
        if(channelArray[channelIndex].hd == 1 &&
           channelArray[channelIndex].major == major) {
            if(tvArray[tvIndex].objectId != channelArray[channelIndex].objectId) {
                TvChanObjId(tvIndex, SOURCE_DIRECTV, channelArray[channelIndex].objectId);
            }
            break;
        }
    }
}

function GamesLoaded(text)
{
    var index;
    var tvIndex;
    index = text.indexOf('list=');
    if(index != -1) {
        text = text.slice(index+5);
    }
    var list = text.split(',');
    trace('GamesLoaded ' + text);
    for(tvIndex = 0; tvIndex < tvArray.length && tvIndex < list.length; ++tvIndex) {
        if(list[tvIndex] != 0) {
            RuwtTune(tvIndex, list[tvIndex]);
        }
    }
}

//https://areyouwatchingthis.com/api/games.xml?postalCode=55415&msoID=DIRECTV&showJustTelevisedGames
function GamesSchedule()
{
    var RUWT = "https://areyouwatchingthis.com/api/games.xml?providerID=DITV527";
    var tvIndex;
    var channelIndex;
    var list = "";
    var major;
    for(tvIndex = 0; tvIndex < tvArray.length; ++tvIndex) {
        major = 0;
        if(tvArray[tvIndex].source == SOURCE_DIRECTV) {
            for(channelIndex = 0; channelIndex < channelArray.length; ++channelIndex) {
                if(channelArray[channelIndex].objectId == tvArray[tvIndex].objectId) {
                    major = channelArray[channelIndex].major;
                    break;
                }
            }
        }
        list += major;
        list += ',';
    }
    trace(list);
    url = "http://" + location.host + ":8081/proxy/" + RUWT + "?list=" + list;
    trace(url);
    //DoPostCallback(url, GamesLoaded);
    GamesLoaded(list);
}



